package	jp.co.sds_corp.streaming;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;

import jp.co.sds_corp.fxutil.CcyPair;
import jp.co.sds_corp.fxutil.MasterCache;
import jp.co.sds_corp.ratemixer.fx.FxRate;
import jp.co.sds_corp.ratemixer.fx.FxRateKey;
import jp.co.sds_corp.transfer.IReceiveListener;
import jp.co.sds_corp.transfer.ReceiveEvent;
import jp.co.sds_corp.transfer.ServiceLoader;
import jp.co.sds_corp.transfer.StatusChangeEvent;
import jp.co.sds_corp.util.common.CmnLog;
import jp.co.sds_corp.util.pooh.simple.SimplePanel;

public class ForwardPanel extends SimplePanel
	implements IReceiveListener
{
	JTable		TBL;
	JScrollPane	sp;
	ForwardModel model;
	ServiceLoader	recv;
	MasterCache	master;
	CcyPair pair;
	FxRateKey key;
	String		ccy1, ccy2;
	int			nPrec;
	String[] allTerm = {
		"SP", "ON", "TN", "1W", "2W",
		"3W", "1M", "2M", "3M", "6M",
		"9M", "1Y", "2Y", "3Y"
	};
	Vector vdat = new Vector();
	HashMap hdat = new HashMap();
	HashMap mapBid = new HashMap();
	HashMap mapAsk = new HashMap();
	HashMap mapThr = new HashMap();

	protected class ClearThread extends Thread
	{
		int		row;
		int		col;
		String	key;

		ClearThread( int row, int col ) {
			this.row = row;
			this.col = col;
			this.key = (String )vdat.get( row );
		}

		public void run() {
			try {
				sleep( 3000 );
				Map map = null;
				switch ( col ) {
				case 2: map = Collections.synchronizedMap( mapBid ); break;
				case 3: map = Collections.synchronizedMap( mapAsk ); break;
				}
				Map mpc = Collections.synchronizedMap( mapThr );
				if ( mpc.get( key + col ).equals( this )) {
					map.remove( key );
					TBL.repaint();
				}
			} catch ( Exception e ) {
			}
		}
	}

	protected class ForwardModel extends AbstractTableModel
	{
		String[] cols = { "Term", "Value", "Bid", "Ask" };

		public ForwardModel() {
		}
		public void clear() {
			vdat.clear();
			hdat.clear();
		}
		public void addTerm( String ccy1, String ccy2, String term ) {
			try {
				FxRate rate = new FxRate( pair, term );
				vdat.add( ccy1 + ccy2 + term );
				hdat.put( ccy1 + ccy2 + term , rate );
			} catch ( Exception e ) {
			}
		}

		public void changeRate( FxRate oldR, FxRate newR ) {
			CcyPair pair = newR.getCcyPair();
			String key = pair.getCcy1().getCode() + pair.getCcy2().getCode()
						+ newR.getTerm();
			hdat.put( key, newR );
			if ( oldR != null && oldR.getBid() != null ) {
				ClearThread clr;
				Map mpc = Collections.synchronizedMap( mapThr );
				int row = vdat.indexOf( key );
				int nCmp;
				Map map;
				map = Collections.synchronizedMap( mapBid );
				nCmp = oldR.getBid().compareTo( newR.getBid() );
				if ( nCmp > 0 ) {
					clr = new ClearThread( row, 2 );
					mpc.put( key + 2, clr );
					map.put( key, Color.blue );
					clr.start();
				} else if ( nCmp < 0 ) {
					clr = new ClearThread( row, 2 );
					mpc.put( key + 2, clr );
					map.put( key, Color.red );
					clr.start();
				}

				map = Collections.synchronizedMap( mapAsk );
				nCmp = oldR.getAsk().compareTo( newR.getAsk() );
				if ( nCmp > 0 ) {
					clr = new ClearThread( row, 3 );
					mpc.put( key + 3, clr );
					map.put( key, Color.blue );
					clr.start();
				} else if ( nCmp < 0 ) {
					clr = new ClearThread( row, 3 );
					mpc.put( key + 3, clr );
					map.put( key, Color.red );
					clr.start();
				}
			}
		}

		public int getColumnCount() {
			return cols.length;
		}
		public String getColumnName( int nClm ) {
			return cols[nClm];
		}
		public int getRowCount() {
			return vdat.size();
		}

		public Object getValueAt( int row, int col ) {
			String key = (String )vdat.get( row );
			FxRate rate = (FxRate )hdat.get( key );
			switch ( col ) {
			case 0: return rate.getTerm();
			case 1:
				if ( rate.getValueDate() != null ) {
					return rate.getValueDate().format( "yyyy/MM/dd" );
				} else {
					return null;
				}
			case 2: return rate.getBid();
			case 3: return rate.getAsk();
			}
			return null;
		}
		public boolean isCellEditable( int row, int col ) {
			return false;
		}
		public Color getColor( int row, int col, Color def ) {
			Map map = null;
			switch ( col ) {
			case 2: map = Collections.synchronizedMap( mapBid ); break;
			case 3: map = Collections.synchronizedMap( mapAsk ); break;
			}
			if ( map != null ) {
				String key = (String )vdat.get( row );
				Color color = (Color )map.get( key );
				if ( color != null ) {
					return color;
				}
			}
			return def;
		}
	}

	protected class FwdCellRenderer extends DefaultTableCellRenderer
	{
		public FwdCellRenderer() {
			super();
		}

		public Component getTableCellRendererComponent( JTable table,
				Object value, boolean isSelected, boolean hasFocus,
				int row, int column )
		{
			setHorizontalTextPosition( SwingConstants.CENTER );
			setFont( new Font( "Dialog", Font.PLAIN, 16 ) );

			ForwardModel model = (ForwardModel)TBL.getModel();
			Color color;
			if ( row == table.getSelectedRow() ) {
				color = table.getSelectionBackground();
			} else {
				color = table.getBackground();
			}
			setBackground( model.getColor( row, column, color ));

			setValue( value );
			return( this );
		}
	}

	public ForwardPanel(){
		super();
	}

	public boolean createPane() {
		setLayout( new BorderLayout() );

		model = new ForwardModel();
		TBL = new JTable( model );
		TBL.setFont( new Font( "Dialog", Font.PLAIN, 16 ));
		TBL.setRowHeight( 18 );
		//TBL.setAutoResizeMode( JTable.AUTO_RESIZE_LAST_COLUMN );
		TBL.setAutoResizeMode( JTable.AUTO_RESIZE_NEXT_COLUMN );
		TBL.setColumnSelectionAllowed( false );
		JScrollPane sp = new JScrollPane( TBL );
		sp.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS );
		add( sp, BorderLayout.CENTER );

		DefaultTableColumnModel clm =
				(DefaultTableColumnModel)TBL.getColumnModel();
		clm.getColumn( 2 ).setCellRenderer( new FwdCellRenderer() );
		clm.getColumn( 3 ).setCellRenderer( new FwdCellRenderer() );

		return true;
	}

	public void initPanel( String ccy1, String ccy2, String prec ) {
		this.ccy1 = ccy1;
		this.ccy2 = ccy2;
		this.nPrec = Integer.valueOf( prec ).intValue();
		try {
			master = MasterCache.getInstance();
			pair = master.getCcyPair( ccy1, ccy2 );
			recv = ServiceLoader.getInstance();
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		model.clear();
		for ( int i = 0; i < allTerm.length; i++ ) {
			model.addTerm( ccy1, ccy2, allTerm[i] );
			int p = nPrec;
			if ( !allTerm[i].equals( "SP" )) {
				p = nPrec + 2;
			}
		}
		key = new FxRateKey( pair, null );
		Iterator itr = recv.getCurrent( key ).iterator();
		while ( itr.hasNext()) {
			FxRate rate = (FxRate )itr.next();
			model.changeRate( null, rate );
		}
		recv.addReceiveListener( key, this );
		TBL.repaint();
	}

	HashMap mapRate = new HashMap();
	public void received( ReceiveEvent e ) {
		FxRate newR = (FxRate )e.getData();
		FxRate oldR = (FxRate )mapRate.get( newR.getKey() );
		CmnLog.debug( this, "changed:" + pair + " " + oldR + "->" + newR );
		try {
			ForwardModel model = (ForwardModel )TBL.getModel();
			model.changeRate( oldR, newR );
			TBL.repaint();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
		mapRate.put( newR.getKey(), newR );
	}

	public void statusChanged( StatusChangeEvent e ) {
	}

	public Component getPopupComponent() {
		return TBL;
	}

	public void closed() {
		recv.removeReceiveListener( key, this );
	}
}
